/*!		@file $RCSfile: window_lib.h,v $									  */
/*!																			  */
/*!		Copyright (c) 2005 - Atmel Corporation								  */
/*!		L															  */
/*!		۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB				  */
/*!																			  */
/*!	 : AT90CAN128/ATmega88/AT90PWM2グݍݖh~					  */
/*!	 : window_lib.h (ײ)											  */
/*!	 : ԑグƋݍݖh~								  */
/*!																			  */
/*!				8MHzU										  */
/*!																			  */
//! @version $Revision: 1.1 $ $Name:  $ $Id: window_lib.h,v 1.1 2006/07/31 15:50:19 fgasnier Exp $
/*!************************** 藘萔̌@ ****************************/
/*!                                                                           */
/*! 擾(AT90PWM2p):													  */
/*!		  (Vpos-Vneg)~~512   Rshunt~~512						  */
/*! ADC = ---------------------- = -----------------~I_shunt				  */
/*!				   Vref					  Vref								  */
/*!																			  */
/*!		  0.005~40(ADMUX`Ԑݒ)~512									  */
/*! ADC = -------------------------------~I = 20~I_shunt					  */
/*!						5 V													  */
/*!																			  */
/*! ADC = 20~I_shuntAA/DϊƎ擾͂̒l20łB			  */
/*!																			  */
/******************************************************************************/
/*! (Nł)苲ݍ臒lɑΉA/Dϊl߂邽߂̑			  */
/*!																			  */
/*!						]피a(m)										  */
/*! I_Pinch_Thres = -------------------~PINCH_THRES						  */
/*!					n(ጸ)~Ke(Nm/A)										  */
/*!																			  */
/*! ͊ADCݍݒl(PINCH)ɂȂ܂B								  */
/*!																			  */
/*!			 ]피a~ADC											  */
/*! PINCH  = -------------------~PINCH_THRES(N(ƭ))						  */
/*!					n~Ke													  */
/*! ̂ɁA																	  */
/*!        ]피a~ADC												  */
/*! GAIN = -------------------   荂x̂߂						  */
/*!				  n~Ke          Œ5ȏ㍶ɈړׂłB			  */
/*!																			  */
/*! Ō:  PINCH = ((GAIN << 5)~PINCH_THRES) >> 5						  */
/*!																			  */
/*!																			  */
/******************************************************************************/
#ifndef _WINDOW_LIB_H
#define _WINDOW_LIB_H

/*_____ ݸٰ ______________________________________________________________*/

#include "config.h"

/*_____ ` _________________________________________________________________*/
//! @defgroup Pinches_detection 苲ݍݖh~oҰ
//! ͑グ̈(A/s̈)`łB
//! @{

//! ƭݒlAd@dƔr邽߂ɊɉZ臒l
#define PINCH_THRES		80

//! (GAIN): ݍ(PINCH)l߂̂ɕKv
//! ɒ`OɍړׂłB
#define GAIN			27	/*!< ȉ:
							 * - GAIN=0.857<<5=(r~g)/(n~ke)
							 * - n:ጸ(30)
							 * - r:]피a(3.5cm<=>0.035m)
							 * - g:ADCƎ擾(25)
							 * - Ke:d@ٸ萔(0.034)
							 * - (Rshunt=5m10ޯADCʂ) */

//! (ADC͈͓̔ŌvZꂽ)rl
//! (ړĂ邽)vZɉEړ܂B
#define PINCH			(unsigned char)(GAIN * PINCH_THRES >> 5)

//! @}

//! @defgroup Window_areas 葋̈Ƒ`
//! ͑グ̈(A/s̈)`łB
//! @{

//! ̍mmŁAݍݖh~̈߂̂Ɏgp܂B
//! ϐĂȂԂEEPROM̂Ɏgpl
#define WINDOW_HEIGHT_MM	450	

//! ΰٌʊm[/mm = hall_tops/window_height
//! ȉ̗̈vZ邽߂̊l
#define TOP_MM				2.0222

//! ̒ォ狲ݍݖh~ɂ܂łmmł̋
#define H_DETECT_MIN_MM		210		//! ŏ200mm: (Ki)

//! ォ狲ݍݖh~܂łΰيm[ł̋
#define H_DETECT_MIN		(U16)(H_DETECT_MIN_MM*TOP_MM)

//! ̒ォ狲ݍݕs܂łmmł̋(+4mm)
#define H_MAX_MM			20		//! ѐڍ+4mm (Ki)

//! ォ狲ݍݖh~s܂łΰيm[ł̋
#define H_MAX				(U16)(H_MAX_MM*TOP_MM)

//! ̒ƒԂ̊m[ł̊苗
#define DOWN				(U16)(WINDOW_HEIGHT_MM*TOP_MM)	// Œx
//! @}

//! EEPROMɊi[\ȖWQ_ő吔
#define PT_NUM_MAX			8

//! ۑꂽWQ_EEPROMڽ
#define PT_NUM_ADR			15

/*_____ ԋ@\` ________________________________________________________*/
//! @defgroup Window_state グԋ@\`
//! ͑グԋ@\`łB
//! @{
#define STOP_STATE		0	//!< グ~: /ߑ҂
#define START_UP_STATE	1	//!< Jڏ: @BIȎԗVяI҂
#define GO_UP_STATE		2	//!< ړ: ʒuƓd̊Ď
#define OBSTRUCT_STATE	3	//!< dĎɂ鋲ݍݏv: ʒu΋ݍݗ̈挟
#define PINCH_STATE		4	//!< ݍ݊mF: tړ(WIȓ)
#define REVERSE_STATE	5	//!< tړI҂: ʒuݍݗ̈։̂Ď
#define STOPING_STATE	6	//!< d@~҂(Ԓ)
#define GO_DOWN_STATE	7	//!< ړ
//! @}

// dWQ_ԋ@\`
#define NORMAL_STATE	1
#define BLOCKING_STATE	2
//#define PINCH_STATE	4
#define SORT_STATE		5

//
//! @defgroup Init_state ԋ@\`
//! window_ctrl(,,)֐ʂグɎgp
//! @{
#define INIT_START_INIT			0
#define INIT_DETECT_BOTTOM		1
#define INIT_START_TOP_DETECT	2
#define INIT_DETECT_TOP			3
#define INIT_COMPUTE_PARAMS		4
#define INIT_BACKLASH_START		5
#define INIT_BACKLASH_DOWN		6
#define INIT_BACKLASH_ACQUIRE	7
#define INIT_END_INIT			8
//! @}

//! @defgroup Init_return_status Ԓ`
//! Ԃ̕񍐂Ɏgp܂B
//! @{
#define INIT_EEP_DONE			0x00
#define INIT_POSITION_REQUEST	0x01
#define INIT_RE_INIT			0x80
//! @}

//! @defgroup window_ctrl_arg window_ctrl()Ұ
//! ݍݖh~̋/֎~up_cmde,down_cmde,no_anti_pinch(window_ctrl()Ұ)ʂグ܂B
//!@{
#define ANTI_PINCH_ENABLED		0	//!< window_ctrl()ʂݍݖh~
#define ANTI_PINCH_DISABLED		1	//!< window_ctrl()ʂݍݖh~֎~

#define CMDE_NO_CMDE			0	//!< ㏸A~A~̖ߗvȂ
#define CMDE_NEW_CMDE			1	//!< ㏸A~A~̖ߗvL
#define CMDE_PERFORMED			2	//!< ㏸A~A~̖ߎs
//@}

#define UPWARD					1	//!< ͏
#define DOWNWARD				0	//!< ͉

/*_____ ^`錾 __________________________________________________________*/

//! @defgroup Eeprom_storage ҰL
//! グҰ(d͒fɉ񕜂)EEPROMɊi[܂B
//! @{

//! EEPROMɑグҰi[̂Ɏgp\
typedef struct
{
  U16 position;			//! Ō̊m̈ʒu
  U8  last_direction;	//! Ō̑
  U8  pinch_threshold;	//! Nł̋ݍ臒l
  U8  gain;				//! d@Ǝ擾ł̗(window_lib.hł̐B)
  U16 window_height_mm;	//! 
  U8  h_max_mm;			//! ѐڍ+4mm(FMVSS 118Ki)
  U16 h_detect_min_mm;	//! ォ狲ݍݖh~܂ł̋(FMVSS 118Ki)
  U16 down;				//! SȑԂΰيm[
  U16 backlash;			//! @BI: 񒼐(ԗV)AʒuɎ
}st_eep_WindowParam;

//! EEPROMҰ\̂eՂɉ͂̂Ɏgp鋤p
typedef union
{
  U8 U8_ptr[sizeof(st_eep_WindowParam)];	//!< EEPROM\̂ւ߲
  st_eep_WindowParam param;					//!< EEPROM\
} un_eep_WindowParam;
//! @}

//! グWQ_ް^̒`
typedef struct
{
  U16 origin;
  U16 end;
  U8 occ;
} st_b_point;

typedef struct
{
  U8 pt_num;
  st_b_point point[PT_NUM_MAX];
} st_b_point_tab;

/*_____ S _________________________________________________________________*/

extern un_eep_WindowParam eep;			// EEPROMҰ @ingroup Eeprom_storage

// ʒuɏՕ
// ͈ [0`down]
// 0͑̒ł̌_łB
// down͋L^\ȍőΰيm[łB
extern U16 position;

// vZꂽd(I(A)<->ADC~ADC)
// ͈: [0`(dl)~(ADC)]
// ݍ݌ô߂ɓd~(ADCl)ƔrׂłB
extern U16 ref;

// d: 肭߂ɎZ@phg()Ȃ΂Ȃ܂B
// ͈ [0`(d~ADC)]
// d(ref)lƔrׂłB
extern U16 current;

// (߂ɏ])
// ͈: [DOWNWARD, UPWARD]
extern U8 direction;

// őʒu
extern U16 down;

// mmɑ΂ΰيm[(ǍDȐx߂8ōړA@ref Window_areasB)
extern U16 top_mm;

// ̒ォ狲ݍݖh~s܂łΰيm[ł̋
// h_max_mmdown̕ϐpČvZ܂B
extern U8 h_max;

/*_____ ^錾 _____________________________________________________________*/

U8 Read_Eep_WindowParameters(void);

// Iɑ~ǍɒƒƎԗVт̌o܂B
U8 init_window_size_position(void);

// @\̏ԂԂ܂B
signed char get_window_state (void);

// ݍݖh~ی삪ɂׂƂԂ܂B
U16 get_h_detect_min(void);

// ݍݖh~ی삪֎~ׂƂԂ܂B
// (\Iɺѐڍ)
U8 get_h_max(void);

// @\ԂAԂԂ܂B
signed char force_window_state (signed char temp);

// Ұݒ肷邽߂EEPROMǂŏԂԂ܂B
//void init_window_parameters(signed char*);
void save_window_parameters(void);
U8 window_ctrl( signed char*, signed char*,U8);

U8 update_point (void);
void clean_point(void);
U8 get_table_indice (U16);
U8 blocking_point(signed char);
U8 get_block_point(U16);
void erase_block_point(void);
void block_point_set_origin(U16 origin);
void init_window_peripherals(void);

#endif  //_WINDOW_LIB_H
