//******************************************************************************
//! @file $RCSfile: can_drv.c,v $
//!
//! Copyright (c) 2006 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧ق͈ȉ̒ʊ֐(ײ)܂݂܂B
//!		   - CAN()
//!		   - AT90CAN128/64/32p
//!
//! ̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! ̧قAVRStudio-412462/WinAVR-20060125ŊmFĂ܂B
//!
//! @version $Revision: 3.10 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "can_drv.h"

//_____ ` ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn can_clear_all_mob
//!
//! ̊֐Ұޯ̓e܂B
//! It reset CANSTMOB,CANCDMOB,CANIDTx,CANIDMxؾĂAMOb[0]`MOb[LAST_MOB_NB]
//! ްFIFO܂B
//!
//! @warning: {łްFIFO܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void can_clear_all_mob(void)
{
U8  mob_number;
/*
  U8  data_index;
*/

  for (mob_number = 0; mob_number < NB_MOB; mob_number++)
  {
	CANPAGE = (mob_number << 4);	//! ߰ގwW
	Can_clear_mob();				//! SMObڼ޽=0
/*
	for (data_index = 0; data_index < NB_DATA_MAX; data_index++)
	{
	  CANMSG = 0;					//! MObްFIFO
	}
*/
  }
}

//------------------------------------------------------------------------------
//  @fn can_get_mob_free
//!
//! ̊֐͗p\ȍŏMObԍ܂MObps\̏ꍇ0xFFԂ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	MObٔԍ
//!			- MOb[0]`MOb[LAST_MOB_NB]
//!			- MObȂ̏ꍇ0xFF
//------------------------------------------------------------------------------
U8 can_get_mob_free(void)
{
  U8 mob_number, page_saved;

  page_saved = CANPAGE;
  for (mob_number = 0; mob_number < NB_MOB; mob_number++)
  {
	Can_set_mob(mob_number);
	if ((CANCDMOB & 0xC0) == 0x00)		//! `Ԑݒ֎~
	{
	  CANPAGE = page_saved;
	  return (mob_number);
	}
  }
  CANPAGE = page_saved;
  return (NO_MOB);
}

//------------------------------------------------------------------------------
//  @fn can_get_mob_status
//!
//! ̊֐RXOK܂TXOK׸ނ1ݒ肳Ăꍇ"̎d
//! MOb"A܂RXOKTXOK׸ނݒ肳ĂȂꍇ"̎d𖢊MOb"
//! Ԃ܂B
//! ̑OɁÅ֐MOb`Ԑݒ肳Ă邩ۂ𒲂ׂMOb`Ԑݒ肳Previously, this function checks if the MOb is configured or not and in
//! ȂꍇA֐"MOB_DISABLE"Ԃ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	MOb
//!			-  MOB_NOT_COMPLETED
//!			-  MOB_TX_COMPLETED
//!			-  MOB_RX_COMPLETED
//!			-  MOB_RX_DLC_WARNING
//!			-  MOB_DISABLE
//!			܂͈ȉُ̈̑gݍ킹łׂłB
//!			-  MOB_ACK_ERROR
//!			-  MOB_FORM_ERROR
//!			-  MOB_CRC_ERROR
//!			-  MOB_STUFF_ERROR
//!			-  MOB_BIT_ERROR
//------------------------------------------------------------------------------
U8 can_get_mob_status(void)
{
  U8 mob_status, canstmob_copy;

  // MOb֎~𒲍
  if ((CANCDMOB & 0xC0) == 0x00) {return(MOB_DISABLE);}

  canstmob_copy = CANSTMOB;		// ̊Ŝ߂̕

  // MObȂA MOb
  // - MOb=0x20ȂMOB_RX_COMPLETED
  // - MOb=0x40ȂMOB_TX_COMPLETED
  // - MOb=0xA0ȂMOB_RX_COMPLETED_DLCW
  mob_status = canstmob_copy & ((1<<DLCW)|(1<<TXOK)|(1<<RXOK));
  if (mob_status != 0) {return(mob_status);}

  // MObŖȂ΁AMObُ킩
  // - MObޯ0=MOB_ACK_ERROR
  // - MObޯ1=MOB_FORM_ERROR
  // - MObޯ2=MOB_CRC_ERROR
  // - MObޯ3=MOB_STUFF_ERROR
  // - MObޯ4=MOB_BIT_ERROR
  mob_status = canstmob_copy & ((1<<BERR)|(1<<SERR)|(1<<CERR)|(1<<FERR)|(1<<AERR));
  if (mob_status != 0) {return(mob_status);}

  // CANSTMOB=0ȂMOB_NOT_COMPLETED
  return(MOB_NOT_COMPLETED);
}

//------------------------------------------------------------------------------
//  @fn can_get_data
//!
//! ̊֐͑IMObҰœnꂽڽް𕡎ʂ܂B
//!
//! @warning	Ȃ
//!
//! @param	CANү ް ڽ
//!
//! @return	Ȃ
//------------------------------------------------------------------------------
void can_get_data(U8* p_can_message_data)
{
  U8 data_index;

  for (data_index = 0; data_index < (Can_get_dlc()); data_index++)
  {
	*(p_can_message_data + data_index) = CANMSG;
  }
}

//------------------------------------------------------------------------------
//  @fn can_auto_baudrate
//!
//! ̊֐CAN޽ł̒ʐM()ꍇɂꎩgCANBTxڼ޽
//! 肵܂B
//!
//! @warning	@\͖Ă܂B
//!
//! @param	mode
//!			0: 葬ްڰĂ]Jn
//!			1: CANBTxڼ޽eŕ]()Jn
//!
//! @return	ްڰď
//!			0: ޯ ݸތ`Ԑݒ̒Ts
//!			1: ްڰĂ͎s܂B
//------------------------------------------------------------------------------
U8 can_auto_baudrate (U8 mode)
{
  U8  u8_temp0;									//! ꎞϐ
  U8  brp, prs, ntq, phs1, phs2;				//! ޯ ݸދ敪ϐ
  U8  phs1_inc;									//! KvȌvZ
  U8  bt_not_found, wait_for_rx, evaluate;		//! "while()"JԂp̌
  U8  try_conf;									//! CAN`Ԑݒp
  U8  ovrtim_flag=0;							//! vv
  U16 conf_index;								//! ޯ ݸގs
  U8  bt_performed;								//! ߂l׸

  //! --- ݒ
  phs1_inc = evaluate = 0;
  bt_performed = 0;
  conf_index = 0;
  bt_not_found = 1;

  //! --- mode=0Ȃ΍ŏlŋ敪ϐAmode=1ȂCANBTxŋ敪ϐ
  if (mode==0)
  {
	brp  = BRP_MIN;
	ntq  = NTQ_MIN;
	phs1 = PHS1_MIN;
	phs2 = PHS2_MIN;
	prs  = ntq - ( phs1 + phs2 + 1 );
	try_conf = 1;		//! ̌`Ԑݒ莎s
	wait_for_rx = 1;	//! "while (wait_for_rx ..."JԂ
  }
  else //! mode = 1
  {
	brp  = Max ((((CANBT1 &  BRP_MSK) >> 1) +1) , BRP_MIN );
	prs  = Max ((((CANBT2 &  PRS_MSK) >> 1) +1) , PRS_MIN );
	phs1 = Max ((((CANBT3 & PHS1_MSK) >> 1) +1) , PHS1_MIN);
	phs2 = Max ((((CANBT3 & PHS2_MSK) >> 4) +1) , PHS2_MIN);
	ntq  = Max ((prs + phs1 + phs2 + 1) , NTQ_MIN);
	phs1_inc = evaluate = 1;	//! "while (evaluate ..."JԂɈڍŝ
	try_conf = 0;				//! ̌`ԐݒT
	wait_for_rx = 0;			//! "while (wait_for_rx ..."JԂ΂
  }

  //! --- SMOb(CANMSG͉܂B)
  for (u8_temp0 = 0; u8_temp0 < NB_MOB; u8_temp0++)
  {
	Can_set_mob(u8_temp0);		//! ߰ގwW
	Can_clear_mob();			//! SMObڼ޽=0x00
  }

  while (bt_not_found == 1)
  {
	if (try_conf == 1)
	{
	  Can_reset();
	  conf_index++;
	  ovrtim_flag=0;

	  //! --- CANBTxڼ޽XV(sjw=phs2/2, 3̎_)
	  CANBT1 = ((brp-1) << BRP);
	  CANBT2 = (((phs2 >> 1)-1) << SJW) |((prs-1) << PRS);
	  CANBT3 = (((phs2-1) << PHS2) | ((phs1-1) << PHS1) | (1<<SMP));

	  //! --- CAN-vݒ - Ԓ߂Ɏgp
	  //! 641(0x281)̉\ȕ]܂Bŏ̂̂͂葬ޯ ݸނ
	  //! AŌ̂̂͂x̂^܂Bߎԑޯ ݸނ͕ύX
	  //! Kvł(0x281>>3=0x50, U8ɍ킹)
	  CANTCON = (U8)(conf_index >> 3);

	  //! --- MOb`Ԑݒ
	  Can_set_mob(MOB_0);					//! MOb-0gp
	  CANSTMOB = 0;							//! ("Can_reset()"ɂčsȂ)MObؾ
	  CANCDMOB = (MOB_Rx_ENA  << CONMOB);	//! M`ԂłMOb 0

	  //! CAN`Ԑݒ
	  CANGCON = (1<<LISTEN) | (1<<ENASTB);	//! ""`ԂCAN틖
	  while ((CANGSTA & (1<<ENFG)) == 0);	//! OKҋ@Wait for Enable OK
	  CANGIT = 0xFF;						//! SʈُOVRTIM׸ނؾ
	}

	//! --- WAIT_FOR_RX LOOP:
	//!     ================
	//! CAN-vɂĎԒ߂ɂȂOɈُȂ""`ԂCANүގM
	//! ss
	//! ȂΐVޯ ݸނ̑g߂"EVALUATE LOOP"ɓn܂B
	while (wait_for_rx == 1)
	{
	  u8_temp0 = CANSTMOB;
	  //! --- RxOKM ?
	  if ((u8_temp0 & (1<<RXOK)) != 0)
	  { //! --- "can_auto_baudrate"֐̐o
		wait_for_rx = 0;						//! "while (wait_for_rx ..."JԂO
		evaluate = 0;							//! "while (evaluate ..."JԂ΂
		bt_not_found = 0;						//! "while (bt_not_found ..."JԂO
		bt_performed = 1;						//! ߂l׸=TRUE
		DISABLE_MOB;							//! MOb-0֎~
		CANGCON = 0x00;							//! CAN֎~""`ؾ
		while ((CANGSTA & (1<<ENFG)) != 0);		//! ֎~OKҋ@
	  }
	  //! --- Ȃ΁Aꂩُ̈Œ~
	  else
	  {
		//! --- MObُ ?
		if ((u8_temp0 & ((1<<BERR)|(1<<SERR)|(1<<CERR)|(1<<FERR)|(1<<AERR))) !=0)
		{
		  evaluate = 1;			//! "while (evaluate ..."JԂɈڍs
		  wait_for_rx = 0;		//! "while (wait_for_rx ..."JԂO
		}

		u8_temp0 = CANGIT;

		//! --- oߎԂɓB ?
		if ((u8_temp0 & (1<<OVRTIM)) !=0 )
		{
		  if (ovrtim_flag==0)
		  {
			//! --- 񎞊Ԓ
			CANGIT |= (1<<OVRTIM);		// OVRTIMؾ
			ovrtim_flag++;
		  }
		  else
		  {
			//! --- 2ڂ̎Ԓ
			CANGIT |= (1<<OVRTIM);		// OVRTIMؾ
			evaluate = 1;				//! "while (evaluate ..."JԂɈڍs
			wait_for_rx = 0;			//! "while (wait_for_rx ..."JԂO
		  }
		}

		//! --- ʈُ ?
		if ((u8_temp0 & ((1<<SERG)|(1<<CERG)|(1<<FERG)|(1<<AERG))) !=0)
		{
		  evaluate = 1;					//! "while (evaluate ..."JԂɈڍs
		  wait_for_rx = 0;				//! "while (wait_for_rx ..."JԂO
		  try_conf = 1;					//! ̌`Ԑݒs
		}
	  }
	} // while (wait_for_rx ...

	//! --- ]JԂ:
	//!     =============
	//! Vޯ ݸތ`ԐݒvZBŏɒiK1AĒiK2=iK
	//! 1AiK1>5ȂΒiK1͒iK2܂͒iK2+1ɓȂ܂B̌ATQ
	//! ̏܂őǍ͑OułBvZA̎_ʒȕ
	//! (80%)Ɖ(75%)܂BSJW̎_͂̌JԂŌvZ
	//! B
	while (evaluate == 1)
	{
	  if (phs1_inc != 0) phs1++;
	  phs1_inc = 1;

	  // --- ȉ̌͒Ophs1̑lɓ܂B
	  if ((phs1 > PHS1_MAX) && (phs2 >= PHS2_MAX))
	  {
		phs1 = PHS1_MIN;
		phs2 = PHS2_MIN;
		phs1_inc = 0;
		if (ntq != NTQ_MAX) ntq++;
		else
		{
		  ntq = NTQ_MIN;
		  if (brp != BRP_MAX) brp++;
		  else
		  {
			//! --- "can_auto_baudrate"֐̎słB
			evaluate = 0;							//! "while (evaluate ..."JԂO
			bt_performed = 0;						//! ߂l׸=FALSE
			bt_not_found = 0;						//! "while (bt_not_found ..."JԂO
			DISABLE_MOB;							//! MOb-0֎~
			CANGCON = 0x00;							//! CAN֎~""`ؾ
			while ((CANGSTA & (1<<ENFG)) != 0);		//! ֎~OKҋ@
		  }
		}
	  }
	  else	// (phs1 > PHS1_MAX ...Ȃ΁A
	  {
		//! --- psh1>5Ȃphs1=phs2܂phs1=phs2+1AȂphs1=phs2
		if (phs1>5)
		{
		  if (phs1>(phs2+1)) phs1=(++phs2);
		}
		else
		{
		  phs2=phs1;
		}
		prs = ntq - ( phs1 + phs2 + 1 );

		//! --- PRSx
		if ((prs <= PRS_MAX) && (prs >= PRS_MIN))
		{
		  //! --- 80%̎_75%ȂΒl󂯓
		  if (((phs2<<2) >= (1+prs+phs1)) && ((phs2+phs2+phs2) <= (1+prs+phs1)))
		  {
			evaluate = 0;		//! "while (evaluate ..."JԂO
			wait_for_rx = 1;	//! V"while (bt_not_found ..."JԂ
		  }
		}
	  }
	} // while (evaluate ...
  } // while (bt_not_found ...

  return (bt_performed);
}

//------------------------------------------------------------------------------
//  @fn can_fixed_baudrate
//!
//! ̊֐͗\ߒ`ꂽlACONF_CANBT1, CONF_CANBT2, CONF_CANBT3CANBTxڼ
//! ݒ肵܂B
//!
//! @warning
//!
//! @param	(gp!)
//!
//! @return	ްڰď
//!			Œ=1: ްڰĂ͎s܂B
//------------------------------------------------------------------------------
U8 can_fixed_baudrate(U8 mode)
{
  Can_reset();
  Can_conf_bt();
  return 1;
}
